import cv2
import numpy as np

# Voy a ejecutarlo para todas las imágenes de carteles que tengo

for i in range(1,23):
    analizar=f'capturas\\car{str(i).rjust(3,"0")}.png'
    print(analizar)
    imagen=cv2.imread(analizar)
    cv2.imshow("Cartel", imagen)

    # Comprimimos en unas pocas líneas lo que hicimos en el programa anterior
    gris=cv2.cvtColor(imagen, cv2.COLOR_BGR2GRAY)
    ret, thresh=cv2.threshold(gris, 140, 255, cv2.THRESH_BINARY)
    contornos, hierarchy = cv2.findContours(thresh, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)
    approx=cv2.minAreaRect(contornos[0])
    angulo=approx[2]
    if abs(angulo)==45:
        alto, ancho=thresh.shape[0], thresh.shape[1]
        M=cv2.getRotationMatrix2D((ancho/2,alto/2),angulo,1)
        thresh_rot=cv2.warpAffine(thresh,M,(ancho,alto))
        imagen_rot=cv2.warpAffine(imagen,M,(ancho,alto))
        contornos, hierarchy = cv2.findContours(thresh_rot, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)

        #Y vuelvo a buscar el rectángulo
        approx=cv2.minAreaRect(contornos[0])
        x=int(approx[0][0])
        y=int(approx[0][1])
        mitadAncho=int(approx[1][0]/2)
        mitadAlto=int(approx[1][1]/2)
        rect=imagen_rot[y-mitadAlto:y+mitadAlto, x-mitadAncho:x+mitadAncho]    
        
        # Cuento los pixeles de cada color
        # Según estos valores que detecté en los carteles
        # Rojo: 79 0 197
        # Amarillo: 0 193 207
        # Blanco: 207 207 207
        # Negro: 0 0 0 
        amarillo=0
        rojo=0
        negro=0
        blanco=0
        for x in range(rect.shape[0]):
            for y in range(rect.shape[1]):
                b, g, r=rect[x,y]
                if b>150 and g>150 and r>150:
                    blanco+=1
                elif b<50 and g<50 and r<50:
                    negro+=1
                elif b>70 and g<10 and r>180:
                    rojo+=1
                elif b<10 and g>180 and r>190:
                    amarillo+=1
        
        print(f"Rojo: {rojo} - Amarillo: {amarillo} - Negro: {negro} - Blanco: {blanco}")
        # Ahora restaría clasificar según la cantidad de puntos de estos colores que encontré.
                
    cv2.waitKey(0)
    cv2.destroyAllWindows()

